function middleSquare(s, n) {
    var b = n >> 1n, f = 1n << n - 1n;
    return () => s = ((s * s) >> b) & f;
}
function middleSquare32(s, n) {
    var b = n >> 1, f = 1 << n - 1;
    return () => s = ((s * s) >> b) & f;
}
function middleSquareWeylSequence(x = 0n, w = 0n, s = 0xb5ad4eceda1ce2a9n) {
    return () => {
        x *= x;
        x += (w += s);
        return x = (x >> 32n) | (x << 32n);
    };
}
const MASK31 = 0x7FFFFFFF;
function tinyMt32Next$(x) {
    var q = x[3];
    var p = (x[0] & MASK31) ^ x[1] ^ x[2];
    p ^= p << 1;
    q ^= q >>> 1 ^ p;
    x[0] = x[1];
    x[1] = x[2];
    x[2] = p ^ q << 10;
    x[3] = q;
    var a = -(q & 1) & x[4];
    var b = -(q & 1) & x[5];
    x[1] ^= a;
    x[2] ^= b;
    return x;
}
function tinyMt32Get(x) {
    var q = x[0] ^ x[2] >> 8;
    var p = x[3] ^ q;
    if (q & 1)
        p ^= x[6];
    return p;
}
function tinyMt32(s = 0, mat1 = 0, mat2 = 0, tmat = 0) {
    var x = [s, mat1, mat2, tmat, mat1, mat2, tmat];
    for (var i = 1; i < 8; i++)
        x[i & 3] ^= i + 1812433253 * (s[(i - 1) & 3] ^ s[(i - 1) & 3] >> 30);
    for (var i = 0; i < 8; i++)
        tinyMt32Next$(x);
    return () => tinyMt32Get(tinyMt32Next$(x));
}
const MASK63 = 0x7fffffffffffffffn;
const MASK64 = 0xffffffffffffffffn;
function tinyMt64Next$(x) {
    x[0] &= MASK63;
    var p = x[0] ^ x[1];
    p ^= p << 12n & MASK64;
    p ^= p >> 32n;
    p ^= p << 32n & MASK64;
    p ^= p << 11n & MASK64;
    x[0] = x[1];
    x[1] = p;
    if (p & 1n) {
        x[0] ^= x[2];
        x[1] ^= x[3] << 32n & MASK64;
    }
    return x;
}
function tinyMt64Get(x) {
    var p = x[0] ^ x[1];
    p ^= x[0] >> 8n;
    if (p & 1n)
        p ^= x[4];
    return p;
}
function tinyMt64(s = 0n, mat1 = 0n, mat2 = 0n, tmat = 0n) {
    var x = [s ^ mat1 << 32n & MASK64, mat2 ^ tmat, mat1, mat2, tmat];
    for (var i = 1; i < 8; i++)
        x[i & 1] ^= BigInt(i) + 6364136223846793005n * (x[(i - 1) & 1] ^ x[(i - 1) & 1] >> 62n);
    return () => tinyMt64Get(tinyMt64Next$(x));
}
export { middleSquare, middleSquare32, middleSquareWeylSequence, tinyMt32, tinyMt64 };
